/**
  Copyright (c) 2006 Freescale Semiconductor
  Freescale Confidential Proprietary
  \file     Timer.c
  \brief    This file handles overflow event and sets a flag 
  \brief    for upper layer interpretation.
  \author   Freescale Semiconductor
  \author   Sensors and Actuator Solutions Division
  \author   Eduardo Muriel
  \version  0.1
  \date     18/10/2007
  \warning  Flags variable must be allocated in direct page for
  \warning  flag test optimization. Allows use of BRSET, BRCLR.
*/

#include "Timer.h"

#ifndef _MCF51QE128_H
    #pragma DATA_SEG _DATA_ZEROPAGE
    FLAGS_REG near frTimer_flags;       /** Flags register */
    #pragma DATA_SEG DEFAULT
#else
    FLAGS_REG  frTimer_flags;       /** Flags register */
#endif

/***********************
Timer interrupt ISR
************************/
void interrupt TIMER_VECTOR_NUM TimerISR(void)
{
  TIMER_CLEAR_TOF();                /** Timer overflow flag clear */
  
  frTimer_flags.Bits.Timeout = 1;   /** Flag set for upper layer */
}