/**
  Copyright (c) 2007 Freescale Semiconductor
  
  \file       main.c
  \brief      Application
  \author     Freescale Semiconductor
  \author     RF, Analog & Sensor Group
  \author     Eduardo Muriel
  \version    1.3
  \date       5/10/2007
                 
* Copyright (c) 2007, Freescale, Inc.  All rights reserved.
*
*
* No part of this document must be reproduced in any form - including copied,
* transcribed, printed or by any electronic means - without specific written
* permission from Freescale Semiconductor.
*
               
*/

#include <hidef.h> /* for EnableInterrupts macro */
#include "main.h"
#include "Proximity.h"
#include "Buzzer.h"
#include "Services.h"

UINT8 App_Init(void);

void main(void) {

  UINT8 u8Status;
  UINT8 u8Count;
  UINT8 u8State;
  
  EnableInterrupts; /* enable interrupts */
  /* include your code here */
  
  u8Status = App_Init();
  
  u8State = STATE_SCAN;
  SCHEDULE_NEXT_SAMPLE(SAMPLE_T);
  
  for(;;) {
    
    switch(u8State)
    {
        case STATE_SCAN:
            if(fStartSample)             
            {
                fStartSample = 0;
                u8Status = UpdateElectrodeStatus(ELECTRODE_ALL);           
    
                if(gesElectrodeStatus)
                {
                    /* Action to be taken */
                    gesElectrodeStatus = 0;
                    u8Status = BuzzerConfigure(&u8Count);
                    if(u8Status == STAT_OK)
                        u8State = STATE_BUZZ;
                }
                else
                {
                    SCHEDULE_NEXT_SAMPLE(SAMPLE_T);
                }
            }            
            break;
        case STATE_BUZZ:
            if(fBuzz)
            {
                BUZZER_SOUND();        
                fBuzz = 0;
                
                if(u8Count-- == 0)
                {
                    u8State = STATE_SCAN;
                    SCHEDULE_NEXT_SAMPLE(SAMPLE_AFTER_BUZZ);
                }    
            }
    
            break;
    }
  } /* loop forever */
  /* please make sure that you never leave main */
}

UINT8 App_Init(void)
{
  UINT8 u8Status;
  
  
  u8Status = MCU_Init();
  
  u8Status = ProximityInit();  
  
  BUZZER_INIT();
  
  return u8Status;
}