/**
  Copyright (c) 2007 Freescale Semiconductor
  
  \file       Buzzer.h
  \brief      Header file for the Buzzer driver module.
  \author     Freescale Semiconductor
  \author     RF, Analog & Sensor Group
  \author     Eduardo Muriel
  \version    1.3
  \date       18/10/2007

  * History:  23/10/2007 - Public and private separations added
              18/10/2007 - File was created.

* Copyright (c) 2007, Freescale, Inc.  All rights reserved.
*
*
* No part of this document must be reproduced in any form - including copied,
* transcribed, printed or by any electronic means - without specific written
* permission from Freescale Semiconductor.
*
  
*/

#include "GPIO.h"
#include "Services.h"

#ifndef _BUZZER_H_
#define _BUZZER_H_

/*******    Public    *****************/
#define BUZZER_FREQ_500HZ        1
#define BUZZER_FREQ_1000HZ       2
#define BUZZER_FREQ_1500HZ       3
#define BUZZER_FREQ_2000HZ       4
#define BUZZER_FREQ_2500HZ       5
#define BUZZER_FREQ_3000HZ       6
#define BUZZER_FREQ_3500HZ       7
#define BUZZER_FREQ_4000HZ       8

#define BUZZER_INIT()     PIN_OUTPUT(BUZZER_PORT(BUZZER_OUTPUT),BUZZER_MASK(BUZZER_OUTPUT))
#define BUZZER_SOUND()    PIN_TOGGLE(BUZZER_PORT(BUZZER_OUTPUT),BUZZER_MASK(BUZZER_OUTPUT))

UINT8 BuzzerConfigure(UINT8 u8FreqIndex, UINT8* pu8BuzzCounter);
/**************************************/

/*******    Private    ****************/
#define BUZZER_OUTPUT     0          /** Buzzer element on virtual port */

#define BUZZER_BASE_FREQ_500HZ       SCHEDULER_CLK
#define BUZZER_BASE_10MS_COUNT       10
#define BUZZER_FREQ_MAX              8

#define BUZZER_SCH(x)                SCHEDULE_NEW_EVENT(x)

#define BUZZER_PORT(x)      vpPort2[x].PinPort    /** Virtual port pointer element */
#define BUZZER_MASK(x)      vpPort2[x].PinMask    /** Virtual port pin mask        */  

/**************************************/

#endif  /** _BUZZER_H_ */