/**
  Copyright (c) 2007 Freescale Semiconductor
  
  \file       Services.h
  \brief      This file provides the services layer, containing mainly clock
  \brief      definitions.
  \author     Freescale Semiconductor
  \author     RF, Analog & Sensor Group
  \author     Eduardo Muriel
  \version    1.3
  \date       23/10/2007
  
* Copyright (c) 2007, Freescale, Inc.  All rights reserved.
*
*
* No part of this document must be reproduced in any form - including copied,
* transcribed, printed or by any electronic means - without specific written
* permission from Freescale Semiconductor.
*
  
*/

#include "Common.h"
#include "SL_HAL_Int.h"
#include "Timer.h"

#ifndef _SERVICES_H_
#define _SERVICES_H_

/******* Application access only ******/
UINT8 MCU_Init(void);
/**************************************/

/*******    Public    *****************/
#define SCHEDULER_CLK     TIMER_CLK

#define SCHEDULE_NEW_EVENT(x)    TIMER_STOP();   \
                                 TIMER_SET_MOD(x); \
                                 TIMER_START()        /** Start sample period     */

#define fScheduledEvent          fTimeout

/**************************************/


/*******    Private   *****************/
#ifdef ICSC1

    #define MCU_CLK       8000      /** FLL output clock frequency/2 in kHz  */
    
    #define ICSC1_INIT    0x07
    #define ICSC2_INIT    0x00 | (BDIV<<6)

    #define TRIM_VAL      *(UINT8 *)(0xFFAF)

    #if (MCU_CLK/BUS_CLK) <= 1
        #define BDIV	    0		/** Specify bus clock divisor */
    #elif (MCU_CLK/BUS_CLK) < 3
        #define BDIV	    1		/** Specify bus clock divisor */
    #elif (MCU_CLK/BUS_CLK) < 7
        #define BDIV	    2		/** Specify bus clock divisor */
    #else (MCU_CLK/BUS_CLK) < 15
        #define BDIV    	3		/** Specify bus clock divisor */
    #endif
    
#elif defined(ICGC1)    

    #define ICGC1_INIT    0x28
    #define ICGC2_INIT    0x00 | (MFD<<4) | RFD
    
    #define MFD           2
    #define RFD           0
    
    #define TRIM_VAL      *(UINT8 *)(0xFFBE)
    
    #define ICG_LOCKED    0x08
    
#endif

/**************************************/

#endif /** _SERVICES_H_ */